var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import React, { useEffect, useId, useImperativeHandle, useRef, useState } from 'react';
import ReactDOM from 'react-dom';
import { useAsync, useElement, useEventCallback, useForkRef } from '@react-devui/hooks';
import { CloseCircleFilled, SwapRightOutlined } from '@react-devui/icons';
import { checkNodeExist, getClassName, getOriginalSize, getVerticalSidePosition } from '@react-devui/utils';
import { usePrefixConfig, useTranslation, useMaxIndex, useLayout } from '../../hooks';
import { TTANSITION_DURING_POPUP } from '../../utils';
import { DBaseDesign } from '../_base-design';
import { DBaseInput } from '../_base-input';
import { DComboboxKeyboardSupport } from '../_keyboard-support';
import { DTransition } from '../_transition';
function DateInput(props, ref) {
    const { children, dClassNamePrefix, dFormControl, dVisible = false, dPlacement = 'bottom-left', dSuffix, dSize, dRange = false, dClearable = false, dDisabled = false, dInputProps, dInputRef, onVisibleChange, afterVisibleChange, onClear } = props, restProps = __rest(props, ["children", "dClassNamePrefix", "dFormControl", "dVisible", "dPlacement", "dSuffix", "dSize", "dRange", "dClearable", "dDisabled", "dInputProps", "dInputRef", "onVisibleChange", "afterVisibleChange", "onClear"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    const { dScrollEl, dResizeEl } = useLayout();
    //#endregion
    //#region Ref
    const boxRef = useRef(null);
    const popupRef = useRef(null);
    const inputRefLeft = useRef(null);
    const inputRefRight = useRef(null);
    const indicatorRef = useRef(null);
    //#endregion
    const dataRef = useRef({});
    const prefix = `${dPrefix}${dClassNamePrefix}`;
    const [dInputRefLeft, dInputRefRight] = dInputRef !== null && dInputRef !== void 0 ? dInputRef : [];
    const combineInputRefLeft = useForkRef(inputRefLeft, dInputRefLeft);
    const combineInputRefRight = useForkRef(inputRefRight, dInputRefRight);
    const asyncCapture = useAsync();
    const [t] = useTranslation();
    const uniqueId = useId();
    const [isFocus, setIsFocus] = useState(false);
    const handleFocusChange = (focus) => {
        var _a, _b;
        (_b = (_a = dataRef.current).clearTid) === null || _b === void 0 ? void 0 : _b.call(_a);
        if (focus) {
            setIsFocus(true);
        }
        else {
            dataRef.current.clearTid = asyncCapture.setTimeout(() => {
                setIsFocus(false);
                onVisibleChange === null || onVisibleChange === void 0 ? void 0 : onVisibleChange(false);
            }, 20);
        }
    };
    const clearable = dClearable && !dVisible && !dDisabled;
    const scrollEl = useElement(dScrollEl);
    const resizeEl = useElement(dResizeEl);
    const containerEl = useElement(() => {
        let el = document.getElementById(`${prefix}-root`);
        if (!el) {
            el = document.createElement('div');
            el.id = `${prefix}-root`;
            document.body.appendChild(el);
        }
        return el;
    });
    const maxZIndex = useMaxIndex(dVisible);
    const [popupPositionStyle, setPopupPositionStyle] = useState({
        top: -9999,
        left: -9999,
    });
    const [transformOrigin, setTransformOrigin] = useState();
    const updatePosition = useEventCallback(() => {
        if (boxRef.current && popupRef.current) {
            const { width, height } = getOriginalSize(popupRef.current);
            const { top, left, transformOrigin } = getVerticalSidePosition(boxRef.current, { width, height }, dPlacement, 8);
            setPopupPositionStyle({
                top,
                left,
                maxWidth: window.innerWidth - left - 20,
            });
            setTransformOrigin(transformOrigin);
        }
    });
    useEffect(() => {
        if (dVisible) {
            const [asyncGroup, asyncId] = asyncCapture.createGroup();
            if (boxRef.current) {
                asyncGroup.onResize(boxRef.current, () => {
                    updatePosition();
                });
            }
            if (popupRef.current) {
                asyncGroup.onResize(popupRef.current, () => {
                    updatePosition();
                });
            }
            return () => {
                asyncCapture.deleteGroup(asyncId);
            };
        }
    }, [asyncCapture, dVisible, uniqueId, updatePosition]);
    useEffect(() => {
        if (dVisible && scrollEl) {
            const [asyncGroup, asyncId] = asyncCapture.createGroup();
            asyncGroup.fromEvent(scrollEl, 'scroll', { passive: true }).subscribe({
                next: () => {
                    updatePosition();
                },
            });
            return () => {
                asyncCapture.deleteGroup(asyncId);
            };
        }
    }, [asyncCapture, dVisible, scrollEl, updatePosition]);
    useEffect(() => {
        if (dVisible && resizeEl) {
            const [asyncGroup, asyncId] = asyncCapture.createGroup();
            asyncGroup.onResize(resizeEl, () => {
                updatePosition();
            });
            return () => {
                asyncCapture.deleteGroup(asyncId);
            };
        }
    }, [asyncCapture, dVisible, resizeEl, updatePosition]);
    const preventBlur = (e) => {
        if (e.target !== inputRefLeft.current && e.target !== inputRefRight.current && e.button === 0) {
            e.preventDefault();
        }
    };
    useEffect(() => {
        if (boxRef.current && indicatorRef.current) {
            let focus = false;
            const boxRect = boxRef.current.getBoundingClientRect();
            if (inputRefLeft.current && document.activeElement === inputRefLeft.current) {
                const rect = inputRefLeft.current.getBoundingClientRect();
                indicatorRef.current.style.cssText = `left:${rect.left - boxRect.left}px;width:${rect.width}px;opacity:1;`;
                focus = true;
            }
            if (inputRefRight.current && document.activeElement === inputRefRight.current) {
                const rect = inputRefRight.current.getBoundingClientRect();
                indicatorRef.current.style.cssText = `left:${rect.left - boxRect.left}px;width:${rect.width}px;opacity:1;`;
                focus = true;
            }
            if (!focus) {
                indicatorRef.current.style.cssText += 'opacity:0;';
            }
        }
    });
    const getInputNode = (isLeft, ksProps) => {
        const [dInputPropsLeft, dInputPropsRight] = dInputProps !== null && dInputProps !== void 0 ? dInputProps : [];
        const inputProps = isLeft ? dInputPropsLeft : dInputPropsRight;
        return (_jsx(DBaseInput, Object.assign({}, inputProps, { ref: isLeft ? combineInputRefLeft : combineInputRefRight, className: getClassName(inputProps === null || inputProps === void 0 ? void 0 : inputProps.className, `${prefix}__input`), type: "text", autoComplete: "off", disabled: dDisabled, onFocus: (e) => {
                var _a;
                (_a = inputProps === null || inputProps === void 0 ? void 0 : inputProps.onFocus) === null || _a === void 0 ? void 0 : _a.call(inputProps, e);
                handleFocusChange(true);
            }, onBlur: (e) => {
                var _a;
                (_a = inputProps === null || inputProps === void 0 ? void 0 : inputProps.onBlur) === null || _a === void 0 ? void 0 : _a.call(inputProps, e);
                handleFocusChange(false);
            }, onKeyDown: (e) => {
                var _a;
                (_a = inputProps === null || inputProps === void 0 ? void 0 : inputProps.onKeyDown) === null || _a === void 0 ? void 0 : _a.call(inputProps, e);
                ksProps.ksOnKeyDown(e);
            }, dFormControl: dFormControl, dFor: isLeft })));
    };
    useImperativeHandle(ref, () => ({
        updatePosition,
    }), [updatePosition]);
    return (_jsxs(_Fragment, { children: [_jsx(DComboboxKeyboardSupport, Object.assign({ dVisible: dVisible, dEditable: true, onVisibleChange: onVisibleChange }, { children: (ksProps) => (_jsx(DBaseDesign, Object.assign({ dCompose: { active: isFocus, disabled: dDisabled }, dFormControl: dFormControl }, { children: _jsxs("div", Object.assign({}, restProps, { ref: boxRef, className: getClassName(restProps.className, prefix, {
                            [`${prefix}--${dSize}`]: dSize,
                            'is-disabled': dDisabled,
                            'is-focus': isFocus,
                        }), onMouseDown: (e) => {
                            var _a;
                            (_a = restProps.onMouseDown) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                            preventBlur(e);
                        }, onMouseUp: (e) => {
                            var _a;
                            (_a = restProps.onMouseUp) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                            preventBlur(e);
                        }, onClick: (e) => {
                            var _a, _b;
                            (_a = restProps.onClick) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                            onVisibleChange === null || onVisibleChange === void 0 ? void 0 : onVisibleChange(true);
                            if (!isFocus) {
                                (_b = inputRefLeft.current) === null || _b === void 0 ? void 0 : _b.focus({ preventScroll: true });
                            }
                        } }, { children: [getInputNode(true, ksProps), dRange && (_jsxs(_Fragment, { children: [_jsx("div", { ref: indicatorRef, className: `${prefix}__indicator` }), _jsx(SwapRightOutlined, { className: `${prefix}__separator` }), getInputNode(false, ksProps)] })), clearable && (_jsx("div", Object.assign({ className: `${prefix}__clear`, role: "button", "aria-label": t('Clear'), onClick: (e) => {
                                    e.stopPropagation();
                                    onClear === null || onClear === void 0 ? void 0 : onClear();
                                } }, { children: _jsx(CloseCircleFilled, {}) }))), checkNodeExist(dSuffix) && (_jsx("div", Object.assign({ className: `${prefix}__icon`, style: { opacity: clearable ? 0 : 1 } }, { children: dSuffix })))] })) }))) })), containerEl &&
                ReactDOM.createPortal(_jsx(DTransition, Object.assign({ dIn: dVisible, dDuring: TTANSITION_DURING_POPUP, onEnterRendered: updatePosition, afterEnter: () => {
                        afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(true);
                    }, afterLeave: () => {
                        afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(false);
                    } }, { children: (state) => {
                        let transitionStyle = {};
                        switch (state) {
                            case 'enter':
                                transitionStyle = { transform: 'scaleY(0.7)', opacity: 0 };
                                break;
                            case 'entering':
                                transitionStyle = {
                                    transition: ['transform', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING_POPUP}ms ease-out`).join(', '),
                                    transformOrigin,
                                };
                                break;
                            case 'leaving':
                                transitionStyle = {
                                    transform: 'scaleY(0.7)',
                                    opacity: 0,
                                    transition: ['transform', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING_POPUP}ms ease-in`).join(', '),
                                    transformOrigin,
                                };
                                break;
                            case 'leaved':
                                transitionStyle = { display: 'none' };
                                break;
                            default:
                                break;
                        }
                        return children({
                            diPopupRef: popupRef,
                            diStyle: Object.assign(Object.assign(Object.assign({}, popupPositionStyle), transitionStyle), { zIndex: maxZIndex }),
                            diOnMouseDown: preventBlur,
                            diOnMouseUp: preventBlur,
                        });
                    } })), containerEl)] }));
}
export const DDateInput = React.forwardRef(DateInput);
//# sourceMappingURL=DateInput.js.map