import type { DSize } from '../../utils';
import type { DFormControl } from '../form';
import React from 'react';
export interface DSelectboxRef {
    updatePosition: () => void;
}
export interface DSelectboxRenderProps {
    sPopupRef: React.MutableRefObject<any>;
    sStyle: React.CSSProperties;
    sOnMouseDown: React.MouseEventHandler;
    sOnMouseUp: React.MouseEventHandler;
}
export interface DSelectboxProps extends Omit<React.HTMLAttributes<HTMLDivElement>, 'children'> {
    children: (props: DSelectboxRenderProps) => JSX.Element | null;
    dClassNamePrefix: string;
    dFormControl?: DFormControl;
    dVisible?: boolean;
    dContent?: React.ReactNode;
    dContentTitle?: string;
    dPlaceholder?: string;
    dSuffix?: React.ReactNode;
    dSize?: DSize;
    dLoading?: boolean;
    dSearchable?: boolean;
    dClearable?: boolean;
    dDisabled?: boolean;
    dInputProps?: React.InputHTMLAttributes<HTMLInputElement>;
    dInputRef?: React.Ref<HTMLInputElement>;
    dUpdatePosition?: (boxEl: HTMLElement, popupEl: HTMLElement) => {
        position: React.CSSProperties;
        transformOrigin?: string;
    } | undefined;
    afterVisibleChange?: (visible: boolean) => void;
    onFocusVisibleChange?: (visible: boolean) => void;
    onClear?: () => void;
}
export declare const DSelectbox: React.ForwardRefExoticComponent<DSelectboxProps & React.RefAttributes<DSelectboxRef>>;
