var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { checkNodeExist, getClassName } from '@react-devui/utils';
import { useComponentConfig, useDValue, usePrefixConfig } from '../../hooks';
import { registerComponentMate, TTANSITION_DURING_BASE } from '../../utils';
import { DCollapseTransition } from '../_transition';
import { DPanel as DNotificationPanel } from '../notification/Panel';
import { DPanel as DToastPanel } from '../toast/Panel';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DAlert' });
export function DAlert(props) {
    const _a = useComponentConfig(COMPONENT_NAME, props), { dVisible, dType, dIcon, dTitle, dDescription, dActions = [], onVisibleChange, afterVisibleChange } = _a, restProps = __rest(_a, ["dVisible", "dType", "dIcon", "dTitle", "dDescription", "dActions", "onVisibleChange", "afterVisibleChange"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    const [visible, changeVisible] = useDValue(true, dVisible, onVisibleChange);
    return (_jsx(DCollapseTransition, Object.assign({ dSize: 0, dIn: visible, dDuring: TTANSITION_DURING_BASE, dStyles: {
            enter: { opacity: 0 },
            entering: {
                transition: ['height', 'padding', 'margin', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms ease-out`).join(', '),
            },
            leaving: {
                opacity: 0,
                transition: ['height', 'padding', 'margin', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms ease-in`).join(', '),
            },
            leaved: { display: 'none' },
        }, afterEnter: () => {
            afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(true);
        }, afterLeave: () => {
            afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(false);
        } }, { children: (ref, collapseStyle) => checkNodeExist(dDescription) ? (_jsx(DNotificationPanel, Object.assign({}, restProps, { ref: ref, className: getClassName(restProps.className, `${dPrefix}alert--notification`), style: Object.assign(Object.assign({}, restProps.style), collapseStyle), dClassNamePrefix: "alert", dType: dType, dIcon: dIcon, dTitle: dTitle, dDescription: dDescription, dActions: dActions, onClose: () => {
                changeVisible(false);
            } }))) : (_jsx(DToastPanel, Object.assign({}, restProps, { ref: ref, className: getClassName(restProps.className, `${dPrefix}alert--toast`), style: Object.assign(Object.assign({}, restProps.style), collapseStyle), dClassNamePrefix: "alert", dType: dType, dIcon: dIcon, dContent: dTitle, dActions: dActions, onClose: () => {
                changeVisible(false);
            } }))) })));
}
//# sourceMappingURL=Alert.js.map