var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { createElement as _createElement } from "react";
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { isUndefined } from 'lodash';
import { useEffect, useMemo, useRef } from 'react';
import { useEventCallback } from '@react-devui/hooks';
import { LoadingOutlined, RightOutlined } from '@react-devui/icons';
import { getClassName } from '@react-devui/utils';
import { usePrefixConfig, useTranslation } from '../../hooks';
import { DCheckbox } from '../checkbox';
import { DVirtualScroll } from '../virtual-scroll';
export function DList(props) {
    const { dGetItemId, dList, dFocusItem, dCustomItem, dMultiple, dFocusVisible, dRoot, onClickItem, onFocusChange, onKeyDown$ } = props, restProps = __rest(props, ["dGetItemId", "dList", "dFocusItem", "dCustomItem", "dMultiple", "dFocusVisible", "dRoot", "onClickItem", "onFocusChange", "onKeyDown$"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    //#region Ref
    const dVSRef = useRef(null);
    //#endregion
    const [t] = useTranslation();
    const isFocus = dFocusItem && dList.findIndex((node) => node.id === dFocusItem.id) !== -1;
    const inFocusNode = (() => {
        if (dFocusItem) {
            for (const node of dList) {
                if (dFocusItem.id === node.id) {
                    return node;
                }
                let _node = dFocusItem;
                while (_node.parent) {
                    _node = _node.parent;
                    if (_node.id === node.id) {
                        return node;
                    }
                }
            }
        }
    })();
    const shouldInitFocus = dRoot && isUndefined(dFocusItem);
    const handleKeyDown = useEventCallback((key) => {
        var _a, _b, _c, _d;
        const focusNode = (node) => {
            if (node) {
                onFocusChange(node);
            }
        };
        switch (key) {
            case 'next':
                focusNode((_a = dVSRef.current) === null || _a === void 0 ? void 0 : _a.scrollByStep(1));
                break;
            case 'prev':
                focusNode((_b = dVSRef.current) === null || _b === void 0 ? void 0 : _b.scrollByStep(-1));
                break;
            case 'first':
                focusNode((_c = dVSRef.current) === null || _c === void 0 ? void 0 : _c.scrollToStart());
                break;
            case 'last':
                focusNode((_d = dVSRef.current) === null || _d === void 0 ? void 0 : _d.scrollToEnd());
                break;
            case 'prev-level':
                if (inFocusNode && inFocusNode.parent) {
                    onFocusChange(inFocusNode.parent);
                }
                break;
            case 'next-level':
                if (inFocusNode && inFocusNode.children) {
                    for (const node of inFocusNode.children) {
                        if (node.enabled) {
                            onFocusChange(node);
                            break;
                        }
                    }
                }
                break;
            case 'click':
                if (inFocusNode) {
                    onClickItem(inFocusNode);
                }
                break;
            default:
                break;
        }
    });
    useEffect(() => {
        if (isFocus || shouldInitFocus) {
            const ob = onKeyDown$.subscribe({
                next: (key) => {
                    handleKeyDown(key);
                },
            });
            return () => {
                ob.unsubscribe();
            };
        }
    }, [handleKeyDown, isFocus, onKeyDown$, shouldInitFocus]);
    const vsPerformance = useMemo(() => ({
        dList,
        dItemSize: 32,
        dItemKey: (item) => item.id,
        dFocusable: (item) => item.enabled,
    }), [dList]);
    return (_jsxs(_Fragment, { children: [_jsx(DVirtualScroll, Object.assign({}, vsPerformance, { ref: dVSRef, dFillNode: _jsx("li", {}), dItemRender: (item, index, { iARIA }) => (_createElement("li", Object.assign({}, iARIA, { key: item.id, id: dGetItemId(item.id), className: getClassName(`${dPrefix}cascader__option`, {
                        'is-focus': item.id === (inFocusNode === null || inFocusNode === void 0 ? void 0 : inFocusNode.id),
                        'is-selected': !dMultiple && item.checked,
                        'is-disabled': item.disabled,
                    }), title: item.origin.label, role: "option", "aria-selected": item.checked, "aria-disabled": item.disabled, onClick: () => {
                        onFocusChange(item);
                        if (!dMultiple || item.isLeaf) {
                            onClickItem(item);
                        }
                    } }),
                    dFocusVisible && item.id === (dFocusItem === null || dFocusItem === void 0 ? void 0 : dFocusItem.id) && _jsx("div", { className: `${dPrefix}focus-outline` }),
                    dMultiple && (_jsx(DCheckbox, { onClick: (e) => {
                            e.stopPropagation();
                            onFocusChange(item);
                            onClickItem(item);
                        }, dModel: item.checked, dDisabled: item.disabled, dIndeterminate: item.indeterminate })),
                    _jsx("div", Object.assign({ className: `${dPrefix}cascader__option-content` }, { children: dCustomItem ? dCustomItem(item.origin) : item.origin.label })),
                    !item.isLeaf && (_jsx("div", Object.assign({ className: `${dPrefix}cascader__option-icon` }, { children: item.origin.loading ? _jsx(LoadingOutlined, { dSpin: true }) : _jsx(RightOutlined, {}) }))))), dFocusItem: inFocusNode, dSize: 264, dPadding: 4 }, { children: ({ vsScrollRef, vsRender, vsOnScroll }) => {
                    var _a, _b, _c, _d;
                    return (
                    // eslint-disable-next-line jsx-a11y/aria-activedescendant-has-tabindex
                    _jsx("ul", Object.assign({ ref: vsScrollRef }, restProps, { className: getClassName(restProps.className, `${dPrefix}cascader__list`), tabIndex: (_a = restProps.tabIndex) !== null && _a !== void 0 ? _a : -1, role: (_b = restProps.role) !== null && _b !== void 0 ? _b : 'listbox', "aria-multiselectable": (_c = restProps['aria-multiselectable']) !== null && _c !== void 0 ? _c : dMultiple, "aria-activedescendant": (_d = restProps['aria-activedescendant']) !== null && _d !== void 0 ? _d : (dRoot && !isUndefined(dFocusItem) ? dGetItemId(dFocusItem.id) : undefined), onScroll: (e) => {
                            var _a;
                            (_a = restProps.onScroll) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                            vsOnScroll(e);
                        } }, { children: dList.length === 0 ? (_jsx("li", Object.assign({ className: `${dPrefix}cascader__empty` }, { children: _jsx("div", Object.assign({ className: `${dPrefix}cascader__option-content` }, { children: t('No Data') })) }))) : (vsRender) })));
                } })), inFocusNode && !inFocusNode.origin.loading && inFocusNode.children && (_jsx(DList, Object.assign({}, props, { id: undefined, dList: inFocusNode.children, dRoot: false })))] }));
}
//# sourceMappingURL=List.js.map