var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { isBoolean, isUndefined } from 'lodash';
import React, { useRef } from 'react';
import { CalendarOutlined } from '@react-devui/icons';
import { getClassName } from '@react-devui/utils';
import { useComponentConfig, usePrefixConfig, useTranslation } from '../../hooks';
import { registerComponentMate } from '../../utils';
import { DButton } from '../button';
import { DTag } from '../tag';
import { DPanel as DTimePickerPanel } from '../time-picker/Panel';
import { DBuilder } from './Builder';
import { DPanel } from './Panel';
import { getCols, orderDate } from './utils';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DDatePicker' });
function DatePicker(props, ref) {
    const _a = useComponentConfig(COMPONENT_NAME, props), { dFormat, dPlaceholder, dOrder = 'ascend', dRange = false, dPresetDate, dConfigDate, dPopupClassName, dShowTime = false } = _a, restProps = __rest(_a, ["dFormat", "dPlaceholder", "dOrder", "dRange", "dPresetDate", "dConfigDate", "dPopupClassName", "dShowTime"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    //#region Ref
    const dDPPRef = useRef(null);
    const dTPPRef = useRef(null);
    //#endregion
    const [t] = useTranslation();
    const format = isUndefined(dFormat)
        ? dShowTime
            ? !isBoolean(dShowTime) && dShowTime.d12Hour
                ? 'YYYY-MM-DD hh:mm:ss A'
                : 'YYYY-MM-DD HH:mm:ss'
            : `YYYY-MM-DD`
        : dFormat;
    const [placeholderLeft = t('DatePicker', dRange ? 'Start date' : 'Select date'), placeholderRight = t('DatePicker', 'End date')] = (dRange ? dPlaceholder !== null && dPlaceholder !== void 0 ? dPlaceholder : [] : [dPlaceholder]);
    const { d12Hour: t12Hour, dConfigTime } = isBoolean(dShowTime) ? {} : dShowTime;
    return (_jsx(DBuilder, Object.assign({}, restProps, { ref: ref, dClassNamePrefix: "date-picker", dFormat: format, dSuffix: _jsx(CalendarOutlined, {}), dPlaceholder: [placeholderLeft, placeholderRight], dOrder: (date) => orderDate(date, dOrder, dShowTime ? undefined : 'date'), dRange: dRange, dPopupClassName: getClassName(dPopupClassName, `${dPrefix}date-picker__popup`), onUpdatePanel: (date) => {
            var _a, _b;
            (_a = dDPPRef.current) === null || _a === void 0 ? void 0 : _a.updateView(date);
            (_b = dTPPRef.current) === null || _b === void 0 ? void 0 : _b.updateView(date);
        } }, { children: ({ pbDate, pbCurrentDate, pbPosition, changeValue }) => (_jsxs(_Fragment, { children: [_jsx(DPanel, { ref: dDPPRef, dDate: pbDate, dAnotherDate: pbCurrentDate[pbPosition === 'start' ? 1 : 0], dConfigDate: dConfigDate ? (...args) => dConfigDate(...args, pbPosition, pbCurrentDate) : undefined, onDateChange: changeValue }), dShowTime &&
                    React.createElement(DTimePickerPanel, {
                        ref: dTPPRef,
                        dTime: pbDate,
                        dCols: getCols(format),
                        d12Hour: t12Hour,
                        dConfigTime: dConfigTime ? (...args) => dConfigTime(...args, pbPosition, pbCurrentDate) : undefined,
                        onTimeChange: changeValue,
                        __header: true,
                    }), _jsx("div", Object.assign({ className: getClassName(`${dPrefix}date-picker__footer`, {
                        [`${dPrefix}date-picker__footer--custom`]: dPresetDate,
                    }) }, { children: dPresetDate ? (Object.keys(dPresetDate).map((name) => {
                        const handleClick = () => {
                            var _a, _b;
                            const d = dPresetDate[name]();
                            changeValue(d);
                            (_a = dDPPRef.current) === null || _a === void 0 ? void 0 : _a.updateView(d[pbPosition === 'start' ? 0 : 1]);
                            (_b = dTPPRef.current) === null || _b === void 0 ? void 0 : _b.updateView(d[pbPosition === 'start' ? 0 : 1]);
                        };
                        return (_jsx(DTag, Object.assign({ className: `${dPrefix}date-picker__footer-button`, role: "button", onClick: handleClick, dTheme: "primary" }, { children: name }), name));
                    })) : (_jsx(DButton, Object.assign({ onClick: () => {
                            var _a, _b;
                            const now = new Date();
                            changeValue(now);
                            (_a = dDPPRef.current) === null || _a === void 0 ? void 0 : _a.updateView(now);
                            (_b = dTPPRef.current) === null || _b === void 0 ? void 0 : _b.updateView(now);
                        }, dType: "link" }, { children: t('DatePicker', dShowTime ? 'Now' : 'Today') }))) }))] })) })));
}
export const DDatePicker = React.forwardRef(DatePicker);
//# sourceMappingURL=DatePicker.js.map