import type { DId, DNestedChildren } from '../../utils';
import React from 'react';
export interface DMenuRef {
    updatePosition: () => void;
}
export declare type DMenuMode = 'horizontal' | 'vertical' | 'popup' | 'icon';
export interface DMenuItem<ID extends DId> {
    id: ID;
    title: React.ReactNode;
    type: 'item' | 'group' | 'sub';
    icon?: React.ReactNode;
    disabled?: boolean;
}
export interface DMenuProps<ID extends DId, T extends DMenuItem<ID>> extends Omit<React.HTMLAttributes<HTMLElement>, 'children'> {
    dList: DNestedChildren<T>[];
    dActive?: ID | null;
    dExpands?: ID[];
    dMode?: DMenuMode;
    dExpandOne?: boolean;
    dExpandTrigger?: 'hover' | 'click';
    onActiveChange?: (id: ID, item: DNestedChildren<T>) => void;
    onExpandsChange?: (ids: ID[], items: DNestedChildren<T>[]) => void;
}
declare function Menu<ID extends DId, T extends DMenuItem<ID>>(props: DMenuProps<ID, T>, ref: React.ForwardedRef<DMenuRef>): JSX.Element | null;
export declare const DMenu: <ID extends DId, T extends DMenuItem<ID>>(props: DMenuProps<ID, T> & React.RefAttributes<DMenuRef>) => ReturnType<typeof Menu>;
export {};
