import type { DNestedChildren, DId, DSize } from '../../utils';
import type { DFormControl } from '../form';
import React from 'react';
export interface DSelectRef {
    updatePosition: () => void;
}
export interface DSelectItem<V extends DId> {
    label: string;
    value: V;
    disabled?: boolean;
}
export interface DSelectProps<V extends DId, T extends DSelectItem<V>> extends Omit<React.HTMLAttributes<HTMLDivElement>, 'children'> {
    dFormControl?: DFormControl;
    dList: DNestedChildren<T>[];
    dModel?: V | null | V[];
    dVisible?: boolean;
    dPlaceholder?: string;
    dSize?: DSize;
    dLoading?: boolean;
    dSearchable?: boolean;
    dClearable?: boolean;
    dDisabled?: boolean;
    dMultiple?: boolean;
    dCustomItem?: (item: DNestedChildren<T>) => React.ReactNode;
    dCustomSelected?: (select: DNestedChildren<T>) => string;
    dCustomSearch?: {
        filter?: (value: string, item: DNestedChildren<T>) => boolean;
        sort?: (a: DNestedChildren<T>, b: DNestedChildren<T>) => number;
    };
    dCreateItem?: (value: string) => DNestedChildren<T> | undefined;
    dPopupClassName?: string;
    dInputProps?: React.InputHTMLAttributes<HTMLInputElement>;
    dInputRef?: React.Ref<HTMLInputElement>;
    onModelChange?: (value: any, item: any) => void;
    onVisibleChange?: (visible: boolean) => void;
    afterVisibleChange?: (visible: boolean) => void;
    onSearch?: (value: string) => void;
    onClear?: () => void;
    onCreateItem?: (item: DNestedChildren<T>) => void;
    onScrollBottom?: () => void;
}
declare function Select<V extends DId, T extends DSelectItem<V>>(props: DSelectProps<V, T>, ref: React.ForwardedRef<DSelectRef>): JSX.Element | null;
export declare const DSelect: <V extends DId, T extends DSelectItem<V>>(props: DSelectProps<V, T> & React.RefAttributes<DSelectRef>) => ReturnType<typeof Select>;
export {};
