/// <reference types="react" />
import type { DId, DSize } from '../../utils';
export interface DTabItem<ID extends DId> {
    id: ID;
    title: React.ReactNode;
    panel: React.ReactNode;
    disabled?: boolean;
    closable?: boolean;
}
export interface DTabsProps<ID extends DId, T extends DTabItem<ID>> extends Omit<React.HTMLAttributes<HTMLDivElement>, 'children'> {
    dList: T[];
    dActive?: ID;
    dPlacement?: 'top' | 'right' | 'bottom' | 'left';
    dCenter?: boolean;
    dType?: 'wrap' | 'slider';
    dSize?: DSize;
    onActiveChange?: (id: ID, item: T) => void;
    onAddClick?: () => void;
    onClose?: (id: ID, item: T) => void;
}
export declare function DTabs<ID extends DId, T extends DTabItem<ID>>(props: DTabsProps<ID, T>): JSX.Element | null;
