import type { DId, DNestedChildren, DSize } from '../../utils';
import type { DFormControl } from '../form';
import type { DTreeItem } from '../tree';
import React from 'react';
export interface DTreeSelectRef {
    updatePosition: () => void;
}
export interface DTreeSelectProps<V extends DId, T extends DTreeItem<V>> extends React.HTMLAttributes<HTMLDivElement> {
    dFormControl?: DFormControl;
    dList: DNestedChildren<T>[];
    dModel?: V | null | V[];
    dExpands?: V[];
    dExpandAll?: boolean;
    dVisible?: boolean;
    dPlaceholder?: string;
    dSize?: DSize;
    dLoading?: boolean;
    dSearchable?: boolean;
    dClearable?: boolean;
    dShowLine?: boolean;
    dDisabled?: boolean;
    dMultiple?: boolean;
    dOnlyLeafSelectable?: boolean;
    dCustomItem?: (item: DNestedChildren<T>) => React.ReactNode;
    dCustomSelected?: (select: DNestedChildren<T>) => string;
    dCustomSearch?: {
        filter?: (value: string, item: DNestedChildren<T>) => boolean;
        sort?: (a: DNestedChildren<T>, b: DNestedChildren<T>) => number;
    };
    dPopupClassName?: string;
    dInputProps?: React.InputHTMLAttributes<HTMLInputElement>;
    dInputRef?: React.Ref<HTMLInputElement>;
    onModelChange?: (value: any, item: any) => void;
    onVisibleChange?: (visible: boolean) => void;
    afterVisibleChange?: (visible: boolean) => void;
    onSearch?: (value: string) => void;
    onClear?: () => void;
    onFirstExpand?: (value: V, item: DNestedChildren<T>) => void;
    onExpandsChange?: (ids: V[], items: DNestedChildren<T>[]) => void;
}
declare function TreeSelect<V extends DId, T extends DTreeItem<V>>(props: DTreeSelectProps<V, T>, ref: React.ForwardedRef<DTreeSelectRef>): JSX.Element | null;
export declare const DTreeSelect: <V extends DId, T extends DTreeItem<V>>(props: DTreeSelectProps<V, T> & React.RefAttributes<DTreeSelectRef>) => ReturnType<typeof TreeSelect>;
export {};
